%define Werror_cflags %{nil}
#use ruby gem install asciidoctor

Summary:	Network traffic analyzer
Summary(de): Analyse des Datenverkehrs im Netzwerk.
Name:		wireshark
Version:	4.2.4
Release:	%mkrel 1
License:	GPLv2+ and GPLv3
Group:		Monitoring
URL:		http://www.wireshark.org
Source1:    wireshark.desktop

#-------------------------------------------
Requires:	dumpcap
Requires:	xdg-utils
Requires:   libcap-utils
#-------------------------------------------
BuildRequires: doxygen
BuildRequires: openssl-devel
BuildRequires: pcre-devel
BuildRequires: bison
BuildRequires: flex
BuildRequires: libtool
BuildRequires: lib64bcg729-devel
BuildRequires: lib64cap-devel
BuildRequires: lib64cares-devel
BuildRequires: lib64ext2fs-devel
BuildRequires: lib64elfutils-devel
BuildRequires: lib64gcrypt-devel
BuildRequires: lib64geoip-devel
BuildRequires: lib64glib2.0-devel
BuildRequires: lib64gnutls-devel
BuildRequires: lib64gpg-error-devel
BuildRequires: lib64krb53-devel
BuildRequires: lib64lua5.2-devel
BuildRequires: lib64nl3-devel
BuildRequires: lib64nghttp2-devel
BuildRequires: lib64pcap-devel
BuildRequires: lib64portaudio-devel
BuildRequires: lib64qt5core-devel
BuildRequires: lib64qt5gui-devel
BuildRequires: lib64qt5multimedia-devel
BuildRequires: lib64qt5printsupport-devel
BuildRequires: lib64qt5widgets-devel
BuildRequires: lib64ssh-devel
BuildRequires: lib64smi-devel
BuildRequires: lib64snappy-devel
BuildRequires: lib64spandsp-devel
BuildRequires: lib64speex1-devel
BuildRequires: lib64xml2-devel
BuildRequires: mesa-devel
BuildRequires: qtbase5-common-devel
BuildRequires: zlib1-devel
BuildRequires: asciidoc
BuildRequires: lib64sbc-devel
BuildRequires: git
BuildRequires: perl-podlators >= 4.140.0
BuildRequires: lib64qt5help-devel
BuildRequires: lib64qt5concurrent-devel
#-------------------------------------------

%description
Wireshark is a network traffic analyzer for Unix-ish operating systems. It is
based on Qt5, a graphical user interface library, and libpcap, a packet
capture and filtering library.

Please logout and back in again after installing this package to gain
access to the capture interfaces.


%description -l de
Wireshark ist eine Analyse des Datenverkehrs im Netzwerk für UNIX Betriebssysteme. 
Es basiert auf Qt5, einer grafischen Benutzerschnittstellenbibliothek und libpcap,
einer Paketerfassungs- und Filter Bibliothek. 


%package devel
Summary:	Development files for %{name}
Group:		Development/Libraries
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	wireshark-devel = %{version}-%{release}
Requires:   %{name}

%description devel
This package contains files used for development with %{name}.

%package	tools
Summary:	Tools for manipulating capture files
Summary(de): Werkzeuge zur Bearbeitung von erfassten Dateien
Group:		Monitoring

%description	tools
Set of tools for manipulating capture files. Contains:

- editcap - Edit and/or translate the format of capture files
- mergecap - Merges two capture files into one
- text2cap - Generate a capture file from an ASCII hexdump of packets

%description tools -l de
Die Sammlung von Werkzeugen zur Bearbeitung von erfassten Dateien enthält:

- editcap - bearbeiten und/oder übersetzt das Format der erfassen Dateien.
- Mergecap - fügt zwei erfasste Dateien zu einer zusammen.
- Text2cap - Erstelle eine erfasste Datei aus hexadezimalen ASCII Paketen.


%package -n	tshark
Summary:	Text-mode network traffic and protocol analyzer
Summary(de): Netzwerk-Datenverkehr und Protokollanalyse im Textmodus
Group:		Monitoring
Requires:	dumpcap

%description -n	tshark
Tshark is a network protocol analyzer. It lets you capture packet data from a
live network, or read packets from a previously saved capture file, either
printing a decoded form of those packets to the standard output or writing the
packets to a file. Twireshark's native capture file format is libpcap format,
which is also the format used by tcpdump and various other tools.


%description -n tshark -l de
Twireshark ist ein Programm zur Analyse von Netzwerkprotokollen. Sie können die 
Paketdaten aus einem Live-Netzwerk erfassen, oder Pakete aus einer zuvor 
gespeicherten Datenerfassung lesen. Sie können die entschlüsselten Pakete entweder 
ausdrucken, oder sie in einer Datei speichern.


%package -n	rawshark
Summary:	Dump and analyze raw libpcap data
Summary(de): Analyse des Datenverkehrs im Netzwerk.
Group:		Monitoring

%description -n	rawshark
Rawshark reads a stream of packets from a file or pipe, and prints a line
describing its output, followed by a set of matching fields for each packet on
stdout.

%description -n rawshark -l de
Twireshark ist ein Programm zur Analyse von Netzwerkprotokollen.


%package -n	dumpcap
Summary:	Network traffic dump tool
Summary(de): Analyse des Datenverkehrs im Netzwerk.
Group:		Monitoring

%description -n	dumpcap
Dumpcap is a network traffic dump tool. It lets you capture packet data from a
live network and write the packets to a file. Many wireshark utilities require it.

%description -n dumpcap -l de
Twireshark ist ein Programm zur Analyse von Netzwerkprotokollen.


%prep


%build
pushd %{_sourcedir}
wget -nc https://2.na.dl.wireshark.org/src/%{name}-%{version}.tar.xz
tar -xf %{name}-%{version}.tar.xz -C %_builddir
popd

pushd %_builddir/%{name}-%{version}
%cmake_qt5 \
	-DCMAKE_INSTALL_LIBDIR:PATH=%{_lib} \
	-DENABLE_EXTRA_COMPILER_WARNINGS:BOOL=ON \
	-DDUMPCAP_INSTALL_OPTION:STRING="suid" \
	-DENABLE_DUMPCAP_GROUP:BOOL=ON \
	-DDUMPCAP_INSTALL_GROUP:STRING="wireshark" \
	-DUSE_qt6=OFF

	%make_build
popd

%install
pushd  %_builddir/%{name}-%{version}
%make_install -C build

# link to main executable
mv %{buildroot}%{_bindir}/wireshark %{buildroot}%{_bindir}/wireshark-qt
ln -s wireshark-qt %{buildroot}%{_bindir}/wireshark

chmod a+r %{buildroot}%{_bindir}/dumpcap

# icons
install -Dpm0644 resources/icons/wsicon16.png %{buildroot}%{_miconsdir}/%{name}.png
install -Dpm0644 resources/icons/wsicon32.png %{buildroot}%{_iconsdir}/%{name}.png
install -Dpm0644 resources/icons/wsicon48.png %{buildroot}%{_liconsdir}/%{name}.png

install -m 0644 %SOURCE1 %{buildroot}/%{_datadir}/applications/wireshark.desktop

# remove uneeded files
find %{buildroot} -name "*.la" -delete
rm -f %{buildroot}/%{_datadir}/applications/wireshark-gtk.desktop

# install includes
mkdir -p %{buildroot}%{_includedir}/wireshark
for include in `find epan -type f -name '*.h'`; do
        mkdir -p %{buildroot}%{_includedir}/wireshark/`dirname $include`
        install -m 0644 $include %{buildroot}%{_includedir}/wireshark/`dirname $include`
done

# remaining include files
install -m 0644 *.h %{buildroot}%{_includedir}/wireshark
mkdir -p %{buildroot}%{_includedir}/wireshark/wiretap
install -m 0644 wiretap/*.h %{buildroot}%{_includedir}/wireshark/wiretap
mkdir -p %{buildroot}%{_includedir}/wireshark/wsutil
install -m 0644 wsutil/*.h %{buildroot}%{_includedir}/wireshark/wsutil

# pkg-config support
install -d %{buildroot}%{_libdir}/pkgconfig/
cat > %{buildroot}%{_libdir}/pkgconfig/wireshark.pc << EOF
prefix=%{_prefix}
exec_prefix=%{_prefix}
libdir=%{_libdir}
includedir=%{_includedir}/wireshark
plugindir=%{_libdir}/wireshark

Name: wireshark
Description: wireshark network packet dissection library
Version: 4.2.4

Requires:
Libs: -L\${libdir} -lwireshark
Cflags: -I\${includedir}
EOF
popd

%pre -n dumpcap
if ! getent group wireshark > /dev/null ;then
	%{_sbindir}/groupadd -r -f wireshark
fi

%posttrans -n dumpcap
SYSUSERS=$(grep [0-9][0-9][0-9]:.*/home /etc/passwd | grep -f /etc/shells | cut -d: -f1)
for idx in $SYSUSERS
do
%{_sbindir}/usermod -a -G wireshark $idx > /dev/null 2>&1
done


%files -n dumpcap
%attr(4750, root, wireshark) %{_bindir}/dumpcap

%files
%{_bindir}/%{name}
%{_bindir}/%{name}-qt
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/plugins/
%{_datadir}/%{name}
%{_iconsdir}/*.png
%{_miconsdir}/*.png
%{_liconsdir}/*.png
%{_iconsdir}/hicolor/*/*/*.png
%{_datadir}/applications/*.desktop
%{_libdir}/libwireshark.so.*
%{_libdir}/libwiretap.so.*
%{_libdir}/libwsutil.so.*
%{_datadir}/metainfo/org.wireshark.Wireshark.metainfo.xml
%{_datadir}/mime/packages/org.wireshark.Wireshark.xml
%{_mandir}

%files tools
%{_bindir}/mmdbresolve
%{_bindir}/capinfos
%{_bindir}/captype
%{_bindir}/editcap
%{_bindir}/idl2wrs
%{_bindir}/mergecap
%{_bindir}/randpkt
%{_bindir}/reordercap
%{_bindir}/text2pcap
%{_bindir}/sharkd
%{_libdir}/%{name}/extcap/ciscodump
%{_libdir}/%{name}/extcap/sshdump
%{_libdir}/%{name}/extcap/androiddump
%{_libdir}/%{name}/extcap/dpauxmon
%{_libdir}/%{name}/extcap/randpktdump
%{_libdir}/%{name}/extcap/udpdump
%{_libdir}/%{name}/extcap/wifidump

%files -n tshark
%{_bindir}/tshark

%files -n rawshark
%{_bindir}/rawshark

%files devel
%{_includedir}/wireshark
%{_libdir}/libwireshark.so
%{_libdir}/libwiretap.so
%{_libdir}/libwsutil.so
%{_libdir}/pkgconfig/*.pc
/usr/share/doc/wireshark/

%changelog
* Thu Mar 28 2024 tex - 4.2.4-1pclos2024
- new version

* Thu Feb 15 2024 tex - 4.2.3-1pclos2024
- new version

* Fri Jan 05 2024 tex - 4.2.2-1pclos2024
- new version

* Wed Jan 03 2024 tex - 4.2.1-1pclos2024
- new version

* Wed Nov 15 2023 tex - 4.2.0-1pclos2023
- new version

* Thu Oct 05 2023 tex - 4.0.10-1pclos2023
- new version

* Thu Aug 24 2023 tex - 4.0.8-1pclos2023
- new version

* Sun Jul 16 2023 tex - 4.0.7-1pclos2023
- new version

* Thu May 25 2023 tex - 4.0.6-1pclos2023
- new version

* Thu Apr 13 2023 tex - 4.0.5-1pclos2023
- new version

* Fri Mar 03 2023 tex - 4.0.4-1pclos2023
- new version

* Wed Jan 18 2023 tex - 4.0.3-1pclos2023
- new version

* Wed Dec 07 2022 tex - 4.0.2-1pclos2022
- new version

* Wed Oct 26 2022 tex - 4.0.1-1pclos2022
- new version

* Sat Oct 08 2022 tex - 4.0.0-1pclos2022
- new version

* Thu Jul 28 2022 tex - 3.7.1-1pclos2022
- new version

* Wed Jun 15 2022 tex - 3.7.0-1pclos2022
- new version

* Wed May 04 2022 tex - 3.6.4-1pclos2022
- new version

* Wed Mar 23 2022 tex - 3.6.3-1pclos2022
- new version

* Thu Feb 10 2022 tex - 3.6.2-1pclos2022
- new version

* Thu Dec 30 2021 tex - 3.6.1-1pclos2022
- new version

* Tue Nov 23 2021 tex - 3.6.0-1pclos2021
- new version

* Thu Nov 18 2021 tex - 3.4.10-1pclos2021
- new version

* Thu Oct 07 2021 tex - 3.4.9-1pclos2021
- new version

* Thu Aug 26 2021 tex - 3.4.8-1pclos2021
- new version

* Thu Jul 15 2021 tex - 3.4.7-1pclos2021
- new version

* Wed Jun 02 2021 tex - 3.4.6-1pclos2021
- new version

* Thu Apr 22 2021 tex - 3.4.5-1pclos2021
- new version

* Wed Mar 10 2021 tex - 3.4.4-1pclos2021
- new version

* Sat Jan 30 2021 tex - 3.4.3-1pclos2021
- new version

* Fri Dec 18 2020 tex - 3.4.2-1pclos2021
- new version

* Thu Dec 10 2020 tex - 3.4.1-1pclos2020
- new version

* Fri Oct 30 2020 tex - 3.4.0-1pclos2020
- new version

* Fri Oct 02 2020 tex - 3.3.1-1pclos2020
- new version

* Wed Sep 16 2020 tex - 3.3.0-1pclos2020
- new version

* Wed Aug 12 2020 tex - 3.2.6-1pclos2020
- new version

* Thu Jul 02 2020 tex - 3.2.5-1pclos2020
- new version

* Wed May 20 2020 tex - 3.2.4-1pclos2020
- new version

* Fri Apr 10 2020 tex - 3.2.3-1pclos2020
- new version

* Thu Feb 27 2020 tex - 3.2.2-1pclos2020
- new version

* Thu Jan 16 2020 tex - 3.2.1-1pclos2020
- new version

* Thu Dec 19 2019 tex - 3.2.0-1pclos2020
- new version

* Thu Dec 05 2019 tex - 3.0.7-1pclos2019
- new version

* Wed Oct 23 2019 tex - 3.0.6-1pclos2019
- new version

* Sat Sep 21 2019 tex - 3.0.5-1pclos2019
- new version

* Thu Sep 12 2019 tex - 3.0.4-1pclos2019
- new version

* Wed Jul 17 2019 tex - 3.0.3-1pclos2019
- new version

* Fri May 24 2019 tex - 3.0.2-1pclos2019
- new version

* Tue Apr 09 2019 tex - 3.0.1-1pclos2019
- new version

* Sun Mar 03 2019 tex - 3.0.0-1pclos2019
- new version

* Wed Feb 27 2019 tex - 2.6.7-1pclos2019
- new version

